<!--
Licensed to the Apache Software Foundation (ASF) under one
or more contributor license agreements.  See the NOTICE file
distributed with this work for additional information
regarding copyright ownership.  The ASF licenses this file
to you under the Apache License, Version 2.0 (the
"License"); you may not use this file except in compliance
with the License.  You may obtain a copy of the License at

  http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing,
software distributed under the License is distributed on an
"AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
KIND, either express or implied.  See the License for the
specific language governing permissions and limitations
under the License.
-->
# Functional Test cases


| TestCase ID | Test Page                  | Test Case Description                    | Test Case Steps                          | Test Data                                | Expected Result                          | Actual Result | Test Result | Jira Bug ID |
| ----------- | -------------------------- | ---------------------------------------- | ---------------------------------------- | ---------------------------------------- | ---------------------------------------- | ------------- | ----------- | ----------- |
| 0101        | login page                 | invalid corp id - check user cannot login the system with invalid corp id. | 1. Input invalid corp id.<br>2. Input password.<br>3. click 'log in' button. |                                          | 1. login failed.                         |               | Passed      |             |
| 0102        | login page                 | invalid password - check user cannot login the system with invalid password. | 1. input valid corp id.<br>2.input invalid password<br>3.click 'log in' button. |                                          | 1. login failed.                         |               | Passed      |             |
| 0103        | login page                 | valid corp id and passoword - check user can login the system with valid corp id and password. | 1. Input the corp id and password.<br>2 click 'log in' button. |                                          | 1. login succesfully                     |               | Passed      |             |
| 0104        | login page                 | remember password                        | 1. Input the corp id and password.<br>2. select 'remember password'.<br>3.click 'log in' button.<br>4. close the brower.<br>5. open the brower again.<br>6. visit the griffin page. |                                          | 1.the id and password are valid.<br>2.'remember password' is checked.<br>3.logged in the griffin homepage.<br>4.the brower is closed.<br>5.the brower is reopened.<br>6.the griffin homepage is opened, instead of the login page. |               | Passed      |             |
| 0105        | login page                 | not remember password                    | 1. Input the corp id and password.<br>2. unselect 'remember password'.<br>3.click 'log in' button.<br>4. close the brower.<br>5. open the brower again.<br>6. visit the griffin page. |                                          | 1.the id and password are valid.<br>2.'remember password' is unchecked.<br>3.logged in the griffin homepage.<br>4.the brower is closed.<br>5.the brower is reopened.<br>6.the login page is opened. |               | Passed      |             |
| 0201        | main page                  | menu bar - check all links in the menu work. | 1. click 'Health'.<br>2. click 'Measures'.<br>3.click 'Create Measure'.<br>4.click 'Data Profiling'.<br>4. click your username -> 'API Docs'. |                                          | 1.show 'health' page.<br>2.show 'measures' page.<br>3.show 'crreate measure' page<br>4.show 'data profiling' page<br>4.open new page for API page. |               | Passed      |             |
| 0202        | main page                  | menu bar - search                        | 1.input a word in the search box.<br>2.do search. |                                          | 1. show search result.                   | unimplemented |             |             |
| 0203        | main page                  | menu bar - user profile                  | 1. click username -> 'user profile'      |                                          | 1. show user profile page                | unimplemented |             |             |
| 0204        | main page                  | menu bar - setting                       | 1. click username -> 'setting'           |                                          | 1. show setting page.                    | unimplemented |             |             |
| 0205        | main page                  | right side - DataAssets                  | 1. click 'DataAssets' link               |                                          | 1.show the data assets page.             |               | Passed      |             |
| 0206        | main page                  | right side - DQ Metrics                  | 1. click 'DQ Metrics' link.              |                                          | 1. show DQ Metrics page                  |               | Passed      |             |
| 0207        | main page                  | right side - statistics for the DQ data. | 1. check the DQ data with the name, last updated time, and the data quality.<br>2. show more for one item, check the dq trend chart. <br>3. click the chart.<br>4. close the zoomed-in chart. |                                          | 1.show all the dq data.<br>2.show the latest dq trend chart for the item.<br>3.the dq chart is zoomed in.<br>4.the zoomed-in chart is closed. |               | Passed      |             |
| 0301        | health page                | heatmap                                  | 1. open 'heatmap' tab.<br>2. check the data quality metrics heatmap.<br>3. click inside the heatmap. |                                          | 1.show the heatmap.<br>2.all the data are shown successfully.<br>3.show the metrics page. |               | Passed      |             |
| 0302        | health page                | check the UI layout when the page is zoomed in and out. | 1.zoom in the page.<br>2.zoom out the page. |                                          | 1. display the page correctly.           |               | Passed      |             |
| 0401        | metrics page               | check metrics data                       | 1. check the dq charts for the metrics.<br>2. click one chart. |                                          | 1. all the data in the dq charts are correct.<br>2. the chart is zoomed in. |               | Passed      |             |
| 0402        | metrics page               | Download Sample                          | 1. click 'download sample'.              |                                          | 1. the sample is downloaded to the local path. | unimplemented |             |             |
| 0403        | metrics page               | Profiling                                | 1. click 'profiling'                     |                                          | 1. show 'profiling'                      | unimplemented |             |             |
| 0404        | metrics page               | check the UI layout when the page is zoomed in and out. | 1.zoom in the page.<br>2.zoom out the page. |                                          | 1. display the page correctly.           |               | Passed      |             |
| 0501        | Measures page              | check the measures data                  | 1. check all the columns are correct or not.<br>2. click one measure name. |                                          | 1. all the data are correct.<br>2. show more information of the measure. |               | Passed      |             |
| 0502        | Measures page              | delete measure                           | 1. click 'delete' icon for one measure.<br>2. confirm to delete the measure. |                                          | 1. open delete confirmation page.<br>2. the measure is removed from the measures table. |               | Passed      |             |
| 0503        | Measures page              | View  measure                            | 1. click 'view' icon for one measure.    |                                          | 1. open view measure page                |               |             |             |
| 0504        | Measures page              | table paging                             | 1. click other pages in the measures table. |                                          | 1.all the data in other pages are show correctly. |               | Passed      |             |
| 0505        | Measures page              | create measure                           | 1. click 'create measure' button         |                                          | 1. open 'create measure' page.           |               | Passed      |             |
| 0506        | Measures page              | check the UI layout when the page is zoomed in and out. | 1.zoom in the page.<br>2.zoom out the page. |                                          | 1. display the page correctly.           |               | Passed      |             |
| 0601        | create measure - accuracy  | create accuracy                          | 1. click 'Measures' -> 'Create Measure' -> 'Accuracy'<br>2.choose the source. Select a schema, e.g. 'default -> demo_src'.<br>3.select one or more attributes, e.g. id, age.<br>4. click 'next'.<br>5. choose the target. Select a schema, e.g. 'default -> demo_tgt'.<br>6. select one or more attributes, e.g. id.<br>7. click 'next'.<br>8. select 'Map To',e.g.'='.<br>9. select a source field for each target.<br>10. click 'next'.<br>11. input the partition configuration for the source and the target,e.g. partition size'1day'.<br>12. input the required information, e.g. measure name 'test_acu'.<br>13.click 'submit'.<br>14. confirm to save. | source schema: 'default -> demo_src'.<br>Source attributes: id, age.<br>target schema: 'default -> demo_tgt'.<br>target attributes, e.g. id.<br>Map to: =.<br>Source Fields: default.demo_src.id.<br>Partition size: '1day'.<br>model name: 'test_acu'. <br> | 1. open 'create accuracy' page.<br>2. the source shcema is selected. The corresponding attributes are shown in the attributes table.<br>3. the source attributes are selected.<br>4. go to 'choose target' step.<br>5. the target schema is selected. The corresponding attributes are shown in the attributes table.<br>6. the target attributes are selected.<br>7. go to 'mapping source and target' step.<br>8. exactly map to the source.<br>9. the source field is selected for each target.<br>10. go to 'partition configuration' step.<br>12. the configuration are input correctly.<br>11. go to 'configuration' step.<br>12. the required info are input correctly.<br>13. open a confirmation page.<br>14. the new model 'test_acu' is created. It is shown in the measures table |               | Passed      |             |
| 0602        | create measure - accuracy  | show error message if no source attribute is selected. | 1. click 'Measures' -> 'Create Measure' -> 'Accuracy'.<br>2. click 'next' |                                          | 1. open 'create accuracy' page.<br>2. show error message to select at least one attribute. |               | Passed      |             |
| 0603        | create measure - accuracy  | show error message if no target attribute is selected. | 1. click 'Measures' -> 'Create Measure' -> 'Accuracy'.<br>2.choose the source. Select a schema, e.g. 'default -> demo_src'.<br>3.select one or more attributes, e.g. id, age.<br>4. click 'next'.<br>5. in the 'target' step, click 'next'. | source schema: 'default -> demo_src'.<br>Source attributes: id, age. | "1. open 'create accuracy' page.<br>2. the source shcema is selected. The corresponding attributes are shown in the attributes table.<br>3. the source attributes are selected.<br>4. go to 'choose target' step.<br>5. show error message to select at least one attribute. |               | Passed      |             |
| 0604        | create measure - accuracy  | show error message if 'map fields' is not set. | 1. click 'Measures' -> 'Create Measure' -> 'Accuracy'<br>2.choose the source. Select a schema, e.g. 'default -> demo_src'.<br>3.select one or more attributes, e.g. id, age.<br>4. click 'next'.<br>5. choose the target. Select a schema, e.g. 'default -> demo_tgt'.<br>6. select one or more attributes, e.g. id.<br>7. click 'next'.<br>8. no selection. click 'next'.<br> | source schema: 'default -> demo_src'.<br>Source attributes: id, age.<br>target schema: 'default -> demo_tgt'.<br>target attributes, e.g. id.<br> | 1. open 'create accuracy' page.<br>2. the source shcema is selected. The corresponding attributes are shown in the attributes table.<br>3. the source attributes are selected.<br>4. go to 'choose target' step.<br>5. the target schema is selected. The corresponding attributes are shown in the attributes table.<br>6. the target attributes are selected.<br>7. go to 'mapping source and target' step.<br>8. no source field is selected for each target.<br>9. show error message. |               | Passed      |             |
| 0605        | create measure - accuracy  | show error if the configuration is invalid | 1. click 'Measures' -> 'Create Measure' -> 'Accuracy'<br>2.choose the source. Select a schema, e.g. 'default -> demo_src'.<br>3.select one or more attributes, e.g. id, age.<br>4. click 'next'.<br>5. choose the target. Select a schema, e.g. 'default -> demo_tgt'.<br>6. select one or more attributes, e.g. id.<br>7. click 'next'.<br>8. select 'Map To',e.g.'='.<br>9. select a source field for each target.<br>10. click 'next'.<br>11.input the partition configuration for the source and the target,e.g. partition size'1day'. <br>12. input invalid value for each field, e.g. measure name 'a test', | source schema: 'default -> demo_src'.<br>Source attributes: id, age.<br>target schema: 'default -> demo_tgt'.<br>target attributes, e.g. id.<br>Map to: =.<br>Source Fields: default.demo_src.id.<br>Partition size: '1day'.<br>model name: 'a test', <br> | 1. open 'create accuracy' page.<br>2. the source shcema is selected. The corresponding attributes are shown in the attributes table.<br>3. the source attributes are selected.<br>4. go to 'choose target' step.<br>5. the target schema is selected. The corresponding attributes are shown in the attributes table.<br>6. the target attributes are selected.<br>7. go to 'mapping source and target' step.<br>8. the source field is selected for each target..<br>9. exactly map to the source.<br>10. the source field is selected for each target.<br>11. go to 'configuration' step.<br>12. show error for invalid value. |               | Passed      |             |
| 0606        | create measure - accuracy  | check the link to add new data asset.    | 1. click the link for adding new data asset. |                                          | 1. go to the 'register data asset' page. | unimplemented |             |             |
| 0607        | create measure - accuracy  | check the UI layout for all the steps when the page is zoomed in and out. | 1.zoom in the page.<br>2.zoom out the page. |                                          | 1.all the steps in the page can be shown correctly. |               | Passed      |             |
| 0701        | create measure - profiling | check measure with profiling type can be created. | 1. click 'Measures' -> 'Create Measure' ->Data Profiling<br>2.choose the target. Select a schema, e.g. 'default -> demo_src'.<br>3.select one attribute, e.g. id.<br>4. click 'next'.<br>5. choose one profiling model, e.g. Null Count ,Total Count.<br>6. click 'next'.<br>7.input the partition configuration for the source,e.g. partition size'1day'. <br>8. click 'next'.<br>9. input valid value for the configuration fields. e.g. measure name 'avalidity'.<br>10. click 'submit'<br>11. click 'save'. | schema: 'default -> demo_src'.<br>Attribute: id.<br>validity model: Null Count ,Total Count.<br>measure name: 'a profiling', <br> | 1. open 'create profiling' page.<br>2. the target schem is selected. The corresponding attributes are shown in the attributes table.<br>3. the attribute is selected.<br>4. go to 'select models' page.<br>5. the profiling model is selected. The description of the model is shown as well.<br>7. go to 'partition configuration' step.<br>8. go to 'configuration' step.<br>9. all the value are valid.<br>10. open a confirmation page.<br>11. the new model 'profiling' is created successfully. it is shown in the measures page. |               | Passed      |             |
| 0702        | create measure - profiling | show error if no target is selected.     | 1. click 'Measures' -> 'Create Measure' ->Data Profiling<br>2. not choose the target.<br>3. click 'next'. |                                          | 1. open 'create profiling' page.<br>2. no target schem is selected.<br>3. show error. |               | Passed      |             |
| 0703        | create measure - profiling | show error if any field is invalid.      | 1. click 'Measures' -> 'Create Measure' ->Data Profiling<br>2.choose the target. Select a schema, e.g. 'default -> demo_src'.<br>3.select one attribute, e.g. id.<br>4. click 'next'.<br>5. choose one profiling model, e.g. Null Count ,Total Count.<br>6. click 'next'.<br>7.input the partition configuration for the source,e.g. partition size'1day'. <br>8. click 'next'.<br>9. input invalid value for the configuration fields. | schema: 'default -> demo_src'.<br>Attribute: id.<br>validity model: Null Count ,Total Count.<br>measure name: 'a profiling', <br> | 1. open 'create profiling' page.<br>2. the target schem is selected. The corresponding attributes are shown in the attributes table.<br>3. the attribute is selected.<br>4. go to 'select models' page.<br>5. the profiling model is selected. The description of the model is shown as well.<br>6. go to 'partition configuration' step.<br>7. go to 'configuration' step.<br>8. show error for the invalid value. |               | Passed      |             |
| 0704        | create measure - profiling | check the UI layout for all the steps when the page is zoomed in and out. | 1.zoom in the page.<br>2.zoom out the page. |                                          | 1.all the steps in the page can be shown correctly. |               | Passed      |             |
| 0801        | data assets                | check the data assets information        | 1. check all the columns are correct or not.<br>2. show more for an asset. |                                          | 1. all the data are correct.<br>2. show the schemas of the asset. |               | Passed      |             |
| 0802        | data assets                | table paging                             | 1. click other pages in the table.       |                                          | 1.all the data in other pages are show correctly. |               | Passed      |             |
| 0803        | data assets                | check the UI layout when the page is zoomed in and out. | 1.zoom in the page.<br>2.zoom out the page. |                                          | 1. display the page correctly.           |               | Passed      |             |

